﻿using System;

namespace RinGOch.HtmlGenerators
{
	public class ErrorHtml
	{
		public static string GenerateString(string summary,Exception exp)
		{
			string temp = HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\error.html");
			temp = temp.Replace("%_summary%",HttpHtmlGenerator.CrLfToBR(HttpUtility.HtmlEncode(summary)));
			if(exp != null)
				temp = temp.Replace("%_exception%",HttpHtmlGenerator.CrLfToBR(HttpUtility.HtmlEncode(exp.Message + "\r\n" + exp.StackTrace)));
			else
				temp = temp.Replace("%_exception%","なし");
			return temp;
		}
		public static byte[] Generate(string summary,Exception exp)
		{
			return HttpServerSetting.HtmlEncoding.GetBytes(GenerateString(summary,exp));
		}
	}
}
