﻿using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace RinGOch
{
	public class OptionDlg : System.Windows.Forms.Form
	{
		#region フォームデザイン
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.CheckBox chkLogging;
		private System.Windows.Forms.TextBox txtLogDir;
		private System.Windows.Forms.CheckBox chkGzip;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.CheckBox checkBox2;
		private System.Windows.Forms.CheckBox chkExtDat;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.CheckBox checkBox3;
		private System.Windows.Forms.CheckBox checkBox4;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// 必要なデザイナ変数です。
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OptionDlg()
		{
			//
			// Windows フォーム デザイナ サポートに必要です。
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent 呼び出しの後に、コンストラクタ コードを追加してください。
			//
			ReadIni();
		}

		/// <summary>
		/// 使用されているリソースに後処理を実行します。
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows フォーム デザイナで生成されたコード 
		/// <summary>
		/// デザイナ サポートに必要なメソッドです。このメソッドの内容を
		/// コード エディタで変更しないでください。
		/// </summary>
		private void InitializeComponent()
		{
			this.chkLogging = new System.Windows.Forms.CheckBox();
			this.txtLogDir = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.chkGzip = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.checkBox2 = new System.Windows.Forms.CheckBox();
			this.chkExtDat = new System.Windows.Forms.CheckBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.checkBox3 = new System.Windows.Forms.CheckBox();
			this.checkBox4 = new System.Windows.Forms.CheckBox();
			this.button1 = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// chkLogging
			// 
			this.chkLogging.Location = new System.Drawing.Point(18, 21);
			this.chkLogging.Name = "chkLogging";
			this.chkLogging.Size = new System.Drawing.Size(374, 19);
			this.chkLogging.TabIndex = 0;
			this.chkLogging.Text = "ゲートウェイのアクセスログを記録する";
			// 
			// txtLogDir
			// 
			this.txtLogDir.Location = new System.Drawing.Point(159, 43);
			this.txtLogDir.Name = "txtLogDir";
			this.txtLogDir.Size = new System.Drawing.Size(209, 19);
			this.txtLogDir.TabIndex = 1;
			this.txtLogDir.Text = "";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(39, 46);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(119, 15);
			this.label1.TabIndex = 2;
			this.label1.Text = "ログを保存するフォルダ：";
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.Location = new System.Drawing.Point(202, 401);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(83, 30);
			this.btnOK.TabIndex = 3;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(285, 401);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(83, 30);
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Text = "キャンセル";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// chkGzip
			// 
			this.chkGzip.Location = new System.Drawing.Point(18, 78);
			this.chkGzip.Name = "chkGzip";
			this.chkGzip.Size = new System.Drawing.Size(323, 18);
			this.chkGzip.TabIndex = 4;
			this.chkGzip.Text = "gzip/deflateを有効にする";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(18, 111);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(225, 15);
			this.label2.TabIndex = 5;
			this.label2.Text = "スレ一覧から掲示板を開いたときのパラメータ：";
			// 
			// comboBox1
			// 
			this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBox1.Items.AddRange(new object[] {
																		 "/l10 (最新10件表示)",
																		 "/l20 (最新20件表示)",
																		 "/l30 (最新30件表示)",
																		 "/l40 (最新40件表示)",
																		 "/l50 (最新50件表示)",
																		 "/l100 (最新100件表示)",
																		 " (すべて表示)"});
			this.comboBox1.Location = new System.Drawing.Point(245, 106);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(123, 20);
			this.comboBox1.TabIndex = 6;
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.textBox1);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.textBox2);
			this.groupBox1.Controls.Add(this.checkBox1);
			this.groupBox1.Controls.Add(this.checkBox2);
			this.groupBox1.Location = new System.Drawing.Point(20, 140);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(348, 142);
			this.groupBox1.TabIndex = 7;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "パスワード：リモートから管理ページへのアクセスを可能にします";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(95, 32);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(224, 19);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(27, 36);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(53, 15);
			this.label3.TabIndex = 0;
			this.label3.Text = "ユーザ名：";
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(27, 62);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(59, 15);
			this.label4.TabIndex = 0;
			this.label4.Text = "パスワード：";
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(95, 61);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(224, 19);
			this.textBox2.TabIndex = 1;
			this.textBox2.Text = "";
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(29, 88);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(302, 18);
			this.checkBox1.TabIndex = 4;
			this.checkBox1.Text = "ローカルから管理ページへのアクセス時にも認証を行う";
			// 
			// checkBox2
			// 
			this.checkBox2.Location = new System.Drawing.Point(29, 112);
			this.checkBox2.Name = "checkBox2";
			this.checkBox2.Size = new System.Drawing.Size(302, 18);
			this.checkBox2.TabIndex = 4;
			this.checkBox2.Text = "認証しなければＧＷにアクセスできないようにする";
			// 
			// chkExtDat
			// 
			this.chkExtDat.Location = new System.Drawing.Point(18, 297);
			this.chkExtDat.Name = "chkExtDat";
			this.chkExtDat.Size = new System.Drawing.Size(340, 16);
			this.chkExtDat.TabIndex = 8;
			this.chkExtDat.Text = "BBS-Dat形式をしたらば@JBBSの拡張形式で出力する";
			this.chkExtDat.Visible = false;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.checkBox3);
			this.groupBox2.Controls.Add(this.checkBox4);
			this.groupBox2.Location = new System.Drawing.Point(20, 289);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(348, 95);
			this.groupBox2.TabIndex = 9;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "メモリ祭り対策＠試験版";
			// 
			// checkBox3
			// 
			this.checkBox3.Location = new System.Drawing.Point(25, 32);
			this.checkBox3.Name = "checkBox3";
			this.checkBox3.Size = new System.Drawing.Size(303, 18);
			this.checkBox3.TabIndex = 0;
			this.checkBox3.Text = "定期的にガベージコレクトを行う";
			// 
			// checkBox4
			// 
			this.checkBox4.Location = new System.Drawing.Point(25, 54);
			this.checkBox4.Name = "checkBox4";
			this.checkBox4.Size = new System.Drawing.Size(303, 18);
			this.checkBox4.TabIndex = 0;
			this.checkBox4.Text = "メモリの使用状況をログファイルに書き込む＠超危険。";
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.Location = new System.Drawing.Point(20, 401);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(83, 30);
			this.button1.TabIndex = 3;
			this.button1.Text = "スレッド情報";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// OptionDlg
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(389, 446);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.chkExtDat);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.comboBox1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.txtLogDir);
			this.Controls.Add(this.chkGzip);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.chkLogging);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.button1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "OptionDlg";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "RinGOch P2PWebGateway の設定";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		#endregion

		#region INI読み取り
		void ReadIni()
		{
			chkLogging.Checked = bool.Parse(IniMgr.read("Gateway","Logging",bool.FalseString));
			txtLogDir.Text = IniMgr.read("Gateway","LogDirectory","C:\\");
			chkGzip.Checked = bool.Parse(IniMgr.read("Gateway","Gzip",bool.FalseString));

			string bbsLatest = IniMgr.read("Gateway","BbsParameter","/l50");
			comboBox1.SelectedIndex = -1;
			if(bbsLatest == "")
				comboBox1.SelectedIndex = comboBox1.Items.Count - 1;
			else
			{
				for(int i=0;i<comboBox1.Items.Count-1;i++)
					if(((string)comboBox1.Items[i]).StartsWith(bbsLatest + " "))
					{
						comboBox1.SelectedIndex = i;
						break;
					}
				if(comboBox1.SelectedIndex == -1)
					comboBox1.SelectedIndex = 4;
			}

			string[] userPass = ((string)IniMgr.read("Gateway","UserPassword",":")).Split(new char[]{':'},2);
			if(userPass.Length == 2)
			{
				textBox1.Text = userPass[0];
				textBox2.Text = userPass[1];
			}
			checkBox1.Checked = bool.Parse(IniMgr.read("Gateway","LocalAuth",bool.FalseString));
			checkBox2.Checked = bool.Parse(IniMgr.read("Gateway","AlwaysAuth",bool.FalseString));
			chkExtDat.Checked = bool.Parse(IniMgr.read("Gateway","UseExtendedDat",bool.FalseString));

			checkBox4.Checked = bool.Parse(IniMgr.read("Gateway","LoggingMemory",bool.FalseString));
			checkBox3.Checked = bool.Parse(IniMgr.read("Gateway","MemoryCleansUpPeriodically",bool.TrueString));
		}
		#endregion

		#region INI書き込み
		void WriteIni()
		{
			IniMgr.write("Gateway","Logging",chkLogging.Checked.ToString());
			IniMgr.write("Gateway","LogDirectory",txtLogDir.Text);
			IniMgr.write("Gateway","Gzip",chkGzip.Checked.ToString());
			IniMgr.write("Gateway","BbsParameter",((string)comboBox1.SelectedItem).Split(' ')[0]);
			IniMgr.write("Gateway","UserPassword",string.Concat(textBox1.Text,":",textBox2.Text));
			IniMgr.write("Gateway","LocalAuth",checkBox1.Checked.ToString());
			IniMgr.write("Gateway","AlwaysAuth",checkBox2.Checked.ToString());
			IniMgr.write("Gateway","UseExtendedDat",chkExtDat.Checked.ToString());

			IniMgr.write("Gateway","LoggingMemory",checkBox4.Checked.ToString());
			IniMgr.write("Gateway","MemoryCleansUpPeriodically",checkBox3.Checked.ToString());
		}
		#endregion

		#region 設定反映
		public static void ApplySetting()
		{
			HttpServerSetting.LoggingMode = bool.Parse(IniMgr.read("Gateway","Logging",bool.FalseString));
			HttpServerSetting.LogFilePath = IniMgr.read("Gateway","LogDirectory","C:\\");
			HttpServerSetting.UseGzipDeflate = bool.Parse(IniMgr.read("Gateway","Gzip",bool.FalseString));
			HttpServerSetting.BBSParameter = IniMgr.read("Gateway","BbsParameter","/l50");
			HttpServerSetting.BasicPassword = IniMgr.read("Gateway","UserPassword",":");
			HttpServerSetting.AuthorizeLocalAccess = bool.Parse(IniMgr.read("Gateway","LocalAuth",bool.FalseString));
			HttpServerSetting.AlwaysAuthorize = bool.Parse(IniMgr.read("Gateway","AlwaysAuth",bool.FalseString));
			HttpServerSetting.UseExtendedDat = bool.Parse(IniMgr.read("Gateway","UseExtendedDat",bool.FalseString));

			HttpServerSetting.LoggingMemory = bool.Parse(IniMgr.read("Gateway","LoggingMemory",bool.FalseString));
			HttpServerSetting.MemoryCleansUpPeriodically = bool.Parse(IniMgr.read("Gateway","MemoryCleansUpPeriodically",bool.TrueString));
		}
		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			WriteIni();
			ApplySetting();
			this.Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			new ThreadWatcher().Show();
		}
	}
}
