using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace RinGOch
{
	/// <summary>
	/// ThreadWatcher ̊Tv̐łB
	/// </summary>
	public class ThreadWatcher : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ColumnHeader columnHeader5;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuPriorityHighest;
		private System.Windows.Forms.MenuItem menuPriorityTimeCritical;
		private System.Windows.Forms.MenuItem menuPriorityAboveNormal;
		private System.Windows.Forms.MenuItem menuPriorityNormal;
		private System.Windows.Forms.MenuItem menuPriorityBelowNormal;
		private System.Windows.Forms.MenuItem menuPriorityLowest;
		private System.Windows.Forms.MenuItem menuPriorityIdle;
		private System.Windows.Forms.MenuItem menuPriority;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.ComponentModel.IContainer components;

		public ThreadWatcher()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			_priorityItems = new MenuItem[]{menuPriorityTimeCritical,menuPriorityHighest,menuPriorityAboveNormal,menuPriorityNormal,menuPriorityBelowNormal,menuPriorityLowest,menuPriorityIdle};
			_priorityValues = new int[]{(int)ThreadPriorityLevel.TimeCritical,(int)ThreadPriorityLevel.Highest,(int)ThreadPriorityLevel.AboveNormal,(int)ThreadPriorityLevel.Normal,(int)ThreadPriorityLevel.BelowNormal,(int)ThreadPriorityLevel.Lowest,(int)ThreadPriorityLevel.Idle};
		}

		MenuItem[] _priorityItems;
		int[] _priorityValues;

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.listView1 = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuPriority = new System.Windows.Forms.MenuItem();
			this.menuPriorityTimeCritical = new System.Windows.Forms.MenuItem();
			this.menuPriorityHighest = new System.Windows.Forms.MenuItem();
			this.menuPriorityAboveNormal = new System.Windows.Forms.MenuItem();
			this.menuPriorityNormal = new System.Windows.Forms.MenuItem();
			this.menuPriorityBelowNormal = new System.Windows.Forms.MenuItem();
			this.menuPriorityLowest = new System.Windows.Forms.MenuItem();
			this.menuPriorityIdle = new System.Windows.Forms.MenuItem();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.CheckBoxes = true;
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																												this.columnHeader1,
																												this.columnHeader2,
																												this.columnHeader3,
																												this.columnHeader4,
																												this.columnHeader5});
			this.listView1.ContextMenu = this.contextMenu1;
			this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView1.FullRowSelect = true;
			this.listView1.GridLines = true;
			this.listView1.HideSelection = false;
			this.listView1.Location = new System.Drawing.Point(0, 0);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(363, 510);
			this.listView1.TabIndex = 0;
			this.listView1.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "";
			this.columnHeader1.Width = 40;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "id";
			this.columnHeader2.Width = 40;
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "Xe[^X";
			this.columnHeader3.Width = 160;
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Dx";
			// 
			// columnHeader5
			// 
			this.columnHeader5.Text = "N";
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																												 this.menuPriority});
			// 
			// menuPriority
			// 
			this.menuPriority.Index = 0;
			this.menuPriority.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																												 this.menuPriorityTimeCritical,
																												 this.menuPriorityHighest,
																												 this.menuPriorityAboveNormal,
																												 this.menuPriorityNormal,
																												 this.menuPriorityBelowNormal,
																												 this.menuPriorityLowest,
																												 this.menuPriorityIdle});
			this.menuPriority.Text = "Dx(&P)";
			this.menuPriority.Select += new System.EventHandler(this.menuPriority_Select);
			// 
			// menuPriorityTimeCritical
			// 
			this.menuPriorityTimeCritical.Index = 0;
			this.menuPriorityTimeCritical.Text = "A^C(&R)";
			this.menuPriorityTimeCritical.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// menuPriorityHighest
			// 
			this.menuPriorityHighest.Index = 1;
			this.menuPriorityHighest.Text = "(&H)";
			this.menuPriorityHighest.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// menuPriorityAboveNormal
			// 
			this.menuPriorityAboveNormal.Index = 2;
			this.menuPriorityAboveNormal.Text = "ʏȏ(&A)";
			this.menuPriorityAboveNormal.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// menuPriorityNormal
			// 
			this.menuPriorityNormal.Index = 3;
			this.menuPriorityNormal.Text = "ʏ(&N)";
			this.menuPriorityNormal.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// menuPriorityBelowNormal
			// 
			this.menuPriorityBelowNormal.Index = 4;
			this.menuPriorityBelowNormal.Text = "ʏȉ(&B)";
			this.menuPriorityBelowNormal.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// menuPriorityLowest
			// 
			this.menuPriorityLowest.Index = 5;
			this.menuPriorityLowest.Text = "(&L)";
			this.menuPriorityLowest.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// menuPriorityIdle
			// 
			this.menuPriorityIdle.Index = 6;
			this.menuPriorityIdle.Text = "ACh(&I)";
			this.menuPriorityIdle.Click += new System.EventHandler(this.menuPriorityItems);
			// 
			// timer1
			// 
			this.timer1.Enabled = true;
			this.timer1.Interval = 1000;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																											 this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																											 this.menuItem2,
																											 this.menuItem3});
			this.menuItem1.Text = "";
			// 
			// menuItem2
			// 
			this.menuItem2.Enabled = false;
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "`FbNꂽXbhE";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "t@C֏o(&W)";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// ThreadWatcher
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(363, 510);
			this.Controls.Add(this.listView1);
			this.Menu = this.mainMenu1;
			this.Name = "ThreadWatcher";
			this.Text = "XbhĎ";
			this.ResumeLayout(false);

		}
		#endregion

		bool _firstCall = false;
		const int ITEM_COUNT = 5;
		const int _flag = 0;
		const int _id = 1;
		const int _status = 2;
		const int _priority = 3;
		const int _time = 4;

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			Process proc = WatchThread.CurrentProcess;
			if(proc == null) return;

			proc.Refresh();

			bool firstCall = _firstCall;
			_firstCall = false;

			ArrayList nonupdatedItems = new ArrayList(listView1.Items);

			foreach(ProcessThread thread in proc.Threads)
			{
				try
				{
					ListViewItem curItem = null;
					for(int i=0;i<listView1.Items.Count;i++)
					{
						ListViewItem item = listView1.Items[i];
						if(int.Parse(item.SubItems[_id].Text) == thread.Id)
						{
							curItem = item;
							break;
						}
					}

					// VKXbh
					if(curItem == null)
					{
						curItem = new ListViewItem(new string[ITEM_COUNT]);
						listView1.Items.Add(curItem);
					}

					// XV
					if(firstCall)
					{
						curItem.SubItems[_flag].Text = "";
					}

					curItem.SubItems[_id].Text = thread.Id.ToString();
					curItem.SubItems[_status].Text = thread.ThreadState.ToString();
					if(thread.ThreadState == System.Diagnostics.ThreadState.Wait)
					{
						curItem.SubItems[_status].Text = string.Concat(curItem.SubItems[_status].Text," (",thread.WaitReason.ToString(),")");
					}
					curItem.SubItems[_priority].Text = thread.PriorityLevel.ToString();
					curItem.SubItems[_time].Text = ((int)DateTime.Now.Subtract(thread.StartTime).TotalSeconds).ToString();
					nonupdatedItems.Remove(curItem);
				}
				catch
				{
				}
			}

			try
			{
				foreach(ListViewItem item in nonupdatedItems)
					listView1.Items.Remove(item);
			}
			catch{}

			try
			{
				int worker,port,worker2,port2;
				ThreadPool.GetMaxThreads(out worker,out port);
				ThreadPool.GetAvailableThreads(out worker2,out port2);
				this.Text = string.Concat("XbhĎ@(Threads:" + proc.Threads.Count.ToString() + " ThreadPool:",(worker-worker2).ToString(),"/",worker.ToString(),"  AsyncPort:",(port-port2).ToString(),"/",port.ToString(),")");
			}
			catch{}
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			Process proc = WatchThread.CurrentProcess;
			if(proc == null) return;

			foreach(ListViewItem item in listView1.CheckedItems)
			{
				int id = int.Parse(item.SubItems[_id].Text);

				for(int i=0;i<proc.Threads.Count;i++)
				{
					ProcessThread pt = proc.Threads[i];
					if(pt.Id == id)
					{
						break;
					}
				}
			}
		}

		private void menuPriority_Select(object sender, System.EventArgs e)
		{
			try
			{
				if(listView1.SelectedItems.Count == 1)
				{
					ListViewItem item = listView1.SelectedItems[0];
					ThreadPriorityLevel tp = (ThreadPriorityLevel)Enum.Parse(typeof(ThreadPriorityLevel),item.SubItems[_priority].Text);

					foreach(MenuItem mitem in _priorityItems)
						mitem.Checked = false;

					_priorityItems[Array.IndexOf(_priorityValues,(int)tp)].Checked = true;
				}
				else if(listView1.SelectedItems.Count > 1)
				{
					foreach(MenuItem item in _priorityItems)
						item.Checked = false;
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void menuPriorityItems(object sender, System.EventArgs e)
		{
			try
			{
				ThreadPriorityLevel newPri = (ThreadPriorityLevel)_priorityValues[Array.IndexOf(_priorityItems,sender)];

				Process proc = WatchThread.CurrentProcess;
				if(proc == null) return;

				foreach(ListViewItem item in listView1.SelectedItems)
				{
					int id = int.Parse(item.SubItems[_id].Text);

					for(int i=0;i<proc.Threads.Count;i++)
					{
						ProcessThread pt = proc.Threads[i];
						if(pt.Id == id)
						{
							pt.PriorityLevel = newPri;
							break;
						}
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			using(SaveFileDialog dlg = new SaveFileDialog())
			{
				dlg.Filter = "eLXgt@C(*.txt)|*.txt";
				if(dlg.ShowDialog(this) == DialogResult.OK)
				{
					timer1.Enabled = false;

					try
					{
						System.Text.StringBuilder buffer = new System.Text.StringBuilder();

						foreach(ListViewItem item in listView1.Items)
						{
							for(int i=0;i<item.SubItems.Count;i++)
							{
								buffer.Append(item.SubItems[i].Text);

								if(i < item.SubItems.Count-1)
									buffer.Append(",");
								else
									buffer.Append("\r\n");
							}
						}

						using(System.IO.StreamWriter writer = new System.IO.StreamWriter(dlg.FileName,false,System.Text.Encoding.Default))
						{
							writer.WriteLine(this.Text);
							writer.Write(buffer.ToString());
						}
					}
					catch(Exception ex)
					{
						MessageBox.Show(ex.ToString());
					}

					timer1.Enabled = true;
				}
			}
		}
	}
}
