﻿using System;
using System.Collections;
using System.IO;

namespace RinGOch
{
	public class WebBbsAbon
	{
		public static Guid[] GetList(Guid pageID)
		{
			try
			{
				ArrayList list = new ArrayList();
				string path = Path.Combine(System.Environment.CurrentDirectory,"Settings\\Ignores\\" + pageID.ToString() + ".txt");
				if(File.Exists(path))
				{
					using(StreamReader reader = new StreamReader(path))
					{
						while (reader.Peek() >= 0) 
						{
							try
							{
								list.Add(new Guid(reader.ReadLine().Split(' ')[0]));
							}
							catch{}
						}
					}
					return (Guid[])list.ToArray(typeof(Guid));
				}
				else
					return new Guid[0];
			}
			catch
			{
				return new Guid[0];
			}
		}

		public static void SetList(Guid pageID,Guid[] guids)
		{
			try
			{
				string path = Path.Combine(System.Environment.CurrentDirectory,"Settings\\Ignores\\" + pageID.ToString() + ".txt");
				if(!Directory.Exists(Path.GetDirectoryName(path))) Directory.CreateDirectory(Path.GetDirectoryName(path));
				using(StreamWriter writer = new StreamWriter(path,false))
				{
					foreach(Guid id in guids)
						writer.WriteLine(id.ToString());
				}
			}
			catch
			{
				return;
			}
		}
	}
}
