﻿using System;
using System.Collections;

namespace RinGOch
{
	public class WebPageUpdateFlag
	{
		static ArrayList _pageID = new ArrayList();
		static ArrayList _flag = new ArrayList();

		public static void SetFlag(Guid page,bool flag)
		{
			if(_pageID.Contains(page))
			{
				_flag[_pageID.IndexOf(page)] = flag;
			}
			else
			{
				lock(_flag.SyncRoot)
				{
					lock(_pageID.SyncRoot)
					{
						_pageID.Add(page);
						_flag.Add(flag);
					}
				}
			}
		}
		public static void RemovePage(Guid id)
		{
			lock(_pageID.SyncRoot)
			{
				lock(_flag.SyncRoot)
				{
					if(_pageID.Contains(id))
					{
						_flag.RemoveAt(_pageID.IndexOf(id));
						_pageID.Remove(id);
					}
				}
			}
		}
		public static bool GetFlag(Guid page,bool defaultFlag)
		{
			if(_pageID.Contains(page))
			{
				return (bool)_flag[_pageID.IndexOf(page)];
			}
			else
				return defaultFlag;
		}
		public static Guid[] GetUpdatedPages()
		{
			ArrayList list= new ArrayList();
			lock(_pageID)
			{
				foreach(Guid id in _pageID)
					if(GetFlag(id,false))
						list.Add(id);
			}
			return (Guid[])list.ToArray(typeof(Guid));
		}
	}
}
