using System;

namespace RinGOch
{
	public enum WebType : int
	{
		// f
		TextOnlyBoard = 0,
		ImageBoard = 1,
		FileBoard = 2,

		// Weby[W
		Page = 8,

		// Wiki
		Wiki = 16,

		// Blog
		Blog = 32
	}

	public class WebTypeToString
	{
		public static string ToString(WebType type)
		{
			switch(type)
			{
				case WebType.TextOnlyBoard:
					return "eLXgf";
				case WebType.ImageBoard:
					return "摜f";
				case WebType.FileBoard:
					return "t@CAbvf";
				case WebType.Page:
					return "y[W";
				case WebType.Wiki:
					return "Wiki";
				case WebType.Blog:
					return "Blog";
				default:
					return "s";
			}
		}
	}
}
