using System;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine
{
	public class BlockStyleCreator
	{
		public static string Create(string data)
		{
			return Regex.Replace(data,"^&amp;bstyle\\(&quot;(?<style>.*?)&quot;\\){(?<contents>(.|\\n)*?)};",new MatchEvaluator(MatchSyntax),RegexOptions.Multiline);
		}

		static string MatchSyntax(Match m)
		{
			if(m.Groups["style"].Success && m.Groups["contents"].Success)
			{
				return "\0<div style=\"" + m.Groups["style"].Value.Replace("\"","") + "\">\r\n" + 
					m.Groups["contents"].Value
					+ "\r\n\0</div>";
			}
			else
				return m.Value;
		}
	}
}
