using System;

namespace RinGOch.WikiEngine.LineData
{
	/// <summary>
	/// \ꂽ^OɑΉL[[h܂ލs\钊ۃNXłB
	/// </summary>
	public abstract class StructuredLineData : ILineData
	{
		private string _keyword;
		private string _class;
		private string _tag;
		protected string _content;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="keyword">L[[h</param>
		/// <param name="content">e</param>
		/// <param name="holdTag">e^O</param>
		public StructuredLineData(string keyword, string content, string tag,string style_class)
		{
			_keyword = keyword;
			_content = content;
			_tag = tag;
			_class = style_class;
		}

		#region ILineData C^[tFCX̎
		
		public string Keyword
		{
			get { return _keyword; }
		}

		public string GetOpenTag(ILineData previous)
		{
			if (previous.GetType().Equals(this.GetType()))
				return "";
			else
			{
				if(_class == "")
                    return "<" + _tag + ">\r\n";
				else
					return "<" + _tag + " class=\"" + _class + "\">\r\n";
			}
		}

		public string GetCloseTag(ILineData next)
		{
			if (next.GetType().Equals(this.GetType()))
				return "";
			else
				return "</" + _tag + ">\r\n";
		}

		public string GetHeading()
		{
			return "";
		}

		public abstract string GetContent();

		#endregion
	}
}
