using System;

namespace RinGOch.WikiEngine.LineData.Chains
{
	/// <summary>
	/// Ώۍsf[^𐶐钊ۃNXłB
	/// </summary>
	public abstract class LineChain
	{
		private LineChain next;

		/// <summary>
		/// ̃`FCݒ肵܂B
		/// </summary>
		public LineChain SetNext(LineChain next)
		{
			this.next = next;

			return next;
		}
        
		/// <summary>
		/// sΏۍsf[^𐶐܂B
		/// </summary>
		public ILineData CreateFrom(string line)
		{
			ILineData lineData = CreateLineData(line);

			if (lineData != null)
				return lineData;
			else if (next != null)
				return next.CreateFrom(line);
			else
				return new ParagraphLineData(line,(!line.StartsWith("[[#newest(")));
		}
        
		/// <summary>
		/// Ώۍsf[^𐶐܂B
		/// </summary>
		protected abstract ILineData CreateLineData(string line);
	}
}
