using System;

namespace RinGOch.WikiEngine.LineData
{
	/// <summary>
	/// ul^Oɑ΂L[[h [---], [--], [-] ܂ލs\NXłB
	/// </summary>
	public class UnorderedListLineData : HierarchicalLineData
	{
		private const string TAG_UL = "ul";

		public UnorderedListLineData(string keyword, string content) : base(keyword, content,TAG_UL)
		{}

		public override string GetContent()
		{
			return "<li class=\"li" + _keyword.Length + "\">" + base._content + "</li>\r\n";
		}
	}
}
